/*
 * 13-QQQQ.c
 */

#include <stdio.h>
#include "s_print.h"
#include "s_input.h"

/*
 *
 */

#define	ARRAY_SIZE	3

/*
 *
 */

typedef	int Matrix3D[ARRAY_SIZE][ARRAY_SIZE];

/*
 *
 */

void output_Matrix3D ( Matrix3D array ) {
	 int i;
	 int j;

	 for ( i = 0; i < ARRAY_SIZE; i++ ) {
		s_print_char ( "|<|"[i] );
		s_print_char ( ' ' );
		for ( j = 0; j < ARRAY_SIZE; j++ ) {
			s_print_int ( array[i][j] );
			s_print_char ( ' ' );
		}
		s_print_char ( "|>|"[i] );
		s_print_char ( '\n' );
	}
}

/*
 *
 */

void input_Matrix3D ( Matrix3D array ) {
	 int i;
	 int j;

	 for ( i = 0; i < ARRAY_SIZE; i++ ) {
		for ( j = 0; j < ARRAY_SIZE; j++ ) {
			s_print_int ( i );
			s_print_string ( ", " );
			s_print_int ( j );
			s_print_string ( " 要素 = " );
			array[i][j] = s_input_int();
		}
	}
}

/*
 *
 */

void copyto_Matrix3D( Matrix3D dst, Matrix3D src ) {
	int i;
	int j;

	 for ( i = 0; i < ARRAY_SIZE; i++ ) {
		for ( j = 0; j < ARRAY_SIZE; j++ ) {
			dst[i][j] = src[i][j];
		}
	}
}

/*
 *
 */

void addto_Matrix3D( Matrix3D dst, Matrix3D src ) {
	int i;
	int j;

	 for ( i = 0; i < ARRAY_SIZE; i++ ) {
		for ( j = 0; j < ARRAY_SIZE; j++ ) {
			dst[i][j] += src[i][j];
		}
	}
} 

/*
 *
 */

void multo_Matrix3D( Matrix3D dst, Matrix3D src ) {
	Matrix3D result;
	int i;
	int j;
	int k;

	 for ( i = 0; i < ARRAY_SIZE; i++ ) {
		for ( j = 0; j < ARRAY_SIZE; j++ ) {
			result[i][j] = 0;
			for ( k = 0; k < ARRAY_SIZE; k++ ) {
				result[i][j] += src[i][k] * dst[k][j];
			}
		}
	}

	copyto_Matrix3D ( dst, result );
}


/*
 *
 */

int main ( void ) {
  Matrix3D m1 = {
    {  -2,  -3,  -1 },
    {   1,   0,   2 },
    {  -2,   2,  -2 } };
  Matrix3D m2 = {
	{  -3,   1,  -3 },
    {   1,  -3,  -3 },
    {   2,   1,   2 } };
	Matrix3D add;
	Matrix3D mul;

	copyto_Matrix3D ( add, m1 );
	addto_Matrix3D ( add, m2 );
	output_Matrix3D ( add );

	copyto_Matrix3D ( mul, m1 );
	multo_Matrix3D ( mul, m2 );
	output_Matrix3D ( mul );

	return 0;
}

/*
 *
 */
